package com.stryker.cmf.accountmgrbean;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.ejb.EJB;
import javax.ejb.Stateless;

@Stateless
public class UserInfoBean implements UserInfo {
	
	@EJB UsersFacadeLocal userfacade;
	@EJB AccountMgr acctMgr;
	
	private String username;
	private String groupname;
	private String firstname;
	private String lastname;
	private String title;
	private String phone;
	private String extension;
	private String email;
	private Date lastsuccess;
	private Integer numfails;
	private Integer disabled;
	

	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public String getGroupname() {
		return groupname;
	}
	public void setGroupname(String groupname) {
		this.groupname = groupname;
	}
	public String getFirstname() {
		return firstname;
	}
	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}
	public String getLastname() {
		return lastname;
	}
	public void setLastname(String lastname) {
		this.lastname = lastname;
	}
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public String getPhone() {
		return phone;
	}
	public void setPhone(String phone) {
		this.phone = phone;
	}
	public String getExtension() {
		return extension;
	}
	public void setExtension(String extension) {
		this.extension = extension;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	
	public UserInfo getInfo(String username) throws AccountMgrException {
		UserInfoBean info = new UserInfoBean();
		Users user = userfacade.findById(username);
		if (user == null) { 
			throw new AccountMgrException("The Account " + user.getUsername() + "does not exist.");
		}
		info.setUsername(user.getUsername());
		info.setGroupname(user.getGroupname());
		info.setFirstname(user.getFirstname());
		info.setLastname(user.getLastname());
		info.setTitle(user.getTitle());
		info.setPhone(user.getPhone());
		info.setExtension(user.getExtension());
		info.setEmail(user.getEmail());
		info.setLastsuccess(user.getLastsuccess());
		info.setNumfails(user.getNumfails());
		info.setDisabled(user.getDisabled());
		return info;
		}
	
	public ArrayList<UserInfo> allUsers() throws AccountMgrException {
		ArrayList<UserInfo> users = new ArrayList<UserInfo>();
		List<Users> facadelist = userfacade.findAll();
		try {
			for (Users user : facadelist) {
				users.add(getInfo(user.getUsername()));
			}
		} catch (AccountMgrException e) {
			throw new AccountMgrException("Unable to process user info list.", e);
		}
		return users;
	}

	public Date getLastsuccess() {
		return lastsuccess;
	}

	public void setLastsuccess(Date lastsuccess) {
		this.lastsuccess = lastsuccess;
	}

	public Integer getNumfails() {
		return numfails;
	}

	public void setNumfails(Integer numfails) {
		this.numfails = numfails;
	}

	public Integer getDisabled() {
		return disabled;
	}

	public void setDisabled(Integer disabled) {
		this.disabled = disabled;
	}
	
	public String toggleDisabled() {
		if (username == null) { 
			System.out.println("YOU ARE AN IDIOT");
		} else System.out.println("IT WORKED THE USERNAME IS: " + username);
		if (acctMgr == null) System.out.println("BUT THIS IS NULL");
		else System.out.println("ACCOUNT MAN EXISTS");
		try {
			acctMgr.userExists(this.username);
		} catch (AccountMgrException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return "refresh";
	}
	
}
