package com.stryker.cmf.accountmgrbean;

import java.util.List;
import java.util.logging.Level;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 * Facade for entity Users.
 * 
 * @see com.stryker.cmf.accountmgrbean.Users
 * @author MyEclipse Persistence Tools
 */
@Stateless
public class UsersFacade implements UsersFacadeLocal {
	// property constants
	public static final String PASSWORD = "password";
	public static final String GROUPNAME = "groupname";
	public static final String FIRSTNAME = "firstname";
	public static final String LASTNAME = "lastname";
	public static final String TITLE = "title";
	public static final String PHONE = "phone";
	public static final String EXTENSION = "extension";
	public static final String EMAIL = "email";
	public static final String NUMFAILS = "numfails";
	public static final String DISABLED = "disabled";

	@PersistenceContext
	private EntityManager entityManager;

	public void save(Users transientInstance) {
		LogUtil.log("saving Users instance", Level.INFO, null);
		try {
			entityManager.persist(transientInstance);
			LogUtil.log("save successful", Level.INFO, null);
		} catch (RuntimeException re) {
			LogUtil.log("save failed", Level.SEVERE, re);
			throw re;
		}
	}

	public void delete(Users persistentInstance) {
		LogUtil.log("deleting Users instance", Level.INFO, null);
		try {
			entityManager.remove(persistentInstance);
			LogUtil.log("delete successful", Level.INFO, null);
		} catch (RuntimeException re) {
			LogUtil.log("delete failed", Level.SEVERE, re);
			throw re;
		}
	}

	public Users update(Users detachedInstance) {
		LogUtil.log("updating Users instance", Level.INFO, null);
		try {
			Users result = entityManager.merge(detachedInstance);
			LogUtil.log("update successful", Level.INFO, null);
			return result;
		} catch (RuntimeException re) {
			LogUtil.log("update failed", Level.SEVERE, re);
			throw re;
		}
	}

	public Users findById(String id) {
		LogUtil.log("finding Users instance with id: " + id, Level.INFO, null);
		try {
			Users instance = entityManager.find(Users.class, id);
			return instance;
		} catch (RuntimeException re) {
			LogUtil.log("find failed", Level.SEVERE, re);
			throw re;
		}
	}

	@SuppressWarnings("unchecked")
	public List<Users> findByProperty(String propertyName, Object value) {
		LogUtil.log("finding Users instance with property: " + propertyName
				+ ", value: " + value, Level.INFO, null);
		try {
			String queryString = "select model from Users model where model."
					+ propertyName + "= :propertyValue";
			return entityManager.createQuery(queryString).setParameter(
					"propertyValue", value).getResultList();
		} catch (RuntimeException re) {
			LogUtil.log("find by property name failed", Level.SEVERE, re);
			throw re;
		}
	}

	public List<Users> findByPassword(Object password) {
		return findByProperty(PASSWORD, password);
	}

	public List<Users> findByGroupname(Object groupname) {
		return findByProperty(GROUPNAME, groupname);
	}

	public List<Users> findByFirstname(Object firstname) {
		return findByProperty(FIRSTNAME, firstname);
	}

	public List<Users> findByLastname(Object lastname) {
		return findByProperty(LASTNAME, lastname);
	}

	public List<Users> findByTitle(Object title) {
		return findByProperty(TITLE, title);
	}

	public List<Users> findByPhone(Object phone) {
		return findByProperty(PHONE, phone);
	}

	public List<Users> findByExtension(Object extension) {
		return findByProperty(EXTENSION, extension);
	}

	public List<Users> findByEmail(Object email) {
		return findByProperty(EMAIL, email);
	}

	public List<Users> findByNumfails(Object numfails) {
		return findByProperty(NUMFAILS, numfails);
	}

	public List<Users> findByDisabled(Object disabled) {
		return findByProperty(DISABLED, disabled);
	}


	public List<Users> findAll() {
		LogUtil.log("finding all Users instances", Level.INFO, null);
		try {
			String queryString = "select model from Users model";
			return entityManager.createQuery(queryString).getResultList();
		} catch (RuntimeException re) {
			LogUtil.log("find all failed", Level.SEVERE, re);
			throw re;
		}
	}
}