package com.stryker.cmf.cimailer;

import javax.ejb.Local;

/**
 * 
 * @author Anthony G. Mattas
 *
 */
@Local
public interface CIMailer {
	
	/**
	 * Add a recipient to the message
	 * @param address
	 * @return Number of Recipients in class
	 * @throws CIMailerException
	 */
	public int addRecipient(String address) throws CIMailerException;
	
	/**
	 * Add a recipient to the message
	 * @param address
	 * @return Number of Recipients in class
	 * @throws CIMailerException
	 */
	public int addCC(String address) throws CIMailerException;
	
	/**
	 * Add a recipient to the message
	 * @param address
	 * @return Number of Recipients in class
	 * @throws CIMailerException
	 */
	public int addBCC(String address) throws CIMailerException;
	
	 /**
	  * Sets the Subject
	  * @param subject
	  * @throws CIMailerException
	  */
	public void setSubject(String subject) throws CIMailerException;
	
	 /**
	  * Sets the message to be send
	  * @param message
	  * @return Message length
	  */
	public void setSender(String senderaddress, String sendername) throws CIMailerException;
	
	 /**
	  * Sets the message being sent
	  * @param message
	  * @return Message length
	  */
	public int setMessage(String message);
	
	 /**
	  * Appends the message being sent
	  * @param message
	  * @return Message length
	  */
	public int appendMessage(String message);
	
	
	 /** 
	  * Sends a message
	  * @throws CIMailerException 
	  */
	public void sendMessage() throws CIMailerException;
	
}
