package com.stryker.cmf.admin;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;

import com.stryker.cmf.accountmgrbean.AccountMgr;
import com.stryker.cmf.accountmgrbean.AccountMgrException;
import com.stryker.cmf.civalidators.CIValidator;
public class Register {
	String username = null;
	String role = null;
	String firstname = null;
	String lastname = null;
	String phone = null;
	String email = null;
	String suffix = null;
	String extension = null;
	String verify = null;
	
	UIInput passwordInput;
		
	@EJB AccountMgr userMgr;
	@EJB CIValidator validator;
	
	public String add() {
		try {
			userMgr.addUser(username, firstname, lastname, suffix, phone, extension, email);
		} catch (AccountMgrException e) {
			return "error";
		}
		return "success";
	}
	
	public void validateUser(FacesContext context, UIComponent component, Object value) {
		try {
			FacesMessage message = new FacesMessage();
			if (userMgr.userExists((String)value) == true) {
				message.setDetail("Username is already in use.");
				message.setSummary("Username is already in use.");
				message.setSeverity(FacesMessage.SEVERITY_ERROR);
				throw new ValidatorException(message);
			}
			if (((String)value).length() > 50) {
				message.setDetail("Username Exceeds Maximum Length.");
				message.setSummary("Username Exceeds Maximum Length.");
				message.setSeverity(FacesMessage.SEVERITY_ERROR);
				throw new ValidatorException(message);
			}
		} catch (AccountMgrException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void validateEmail(FacesContext context, UIComponent component, Object value) {
		FacesMessage message = new FacesMessage();
		if (validator.email((String)value) == false) {
			message.setDetail("E-mail address not formatted properly.");
			message.setSummary("E-mail address not valid.");
			message.setSeverity(FacesMessage.SEVERITY_ERROR);
			throw new ValidatorException(message);
		}
		if (((String)value).length() > 75) {
			message.setDetail("E-mail Exceeds Maximum Length.");
			message.setSummary("E-mail Exceeds Maximum Length.");
			message.setSeverity(FacesMessage.SEVERITY_ERROR);
			throw new ValidatorException(message);
		}
	}
	
	public void validateName(FacesContext context, UIComponent component, Object value) {
		FacesMessage message = new FacesMessage();
		if (((String)value).length() > 50) {
			message.setDetail("Name Exceeds Maximum Length.");
			message.setSummary("Name Exceeds Maximum Length.");
			message.setSeverity(FacesMessage.SEVERITY_ERROR);
			throw new ValidatorException(message);
		}
	}
	
	public void validateShort(FacesContext context, UIComponent component, Object value) {
		FacesMessage message = new FacesMessage();
		if (((String)value).length() > 10) {
			message.setDetail("Exceeds Maximum Length.");
			message.setSummary("Exceeds Maximum Length.");
			message.setSeverity(FacesMessage.SEVERITY_ERROR);
			throw new ValidatorException(message);
		}
	}
	
	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public String getFirstname() {
		return firstname;
	}
	public void setFirstname(String firstname) {
		this.firstname = firstname;
	}
	public String getLastname() {
		return lastname;
	}
	public void setLastname(String lastname) {
		this.lastname = lastname;
	}
	public String getRole() {
		return role;
	}
	public void setRole(String role) {
		this.role = role;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getPhone() {
		return phone;
	}
	public void setPhone(String phone) {
		this.phone = phone;
	}
	public String getSuffix() {
		return suffix;
	}
	public void setSuffix(String suffix) {
		this.suffix = suffix;
	}
	public String getExtension() {
		return extension;
	}
	public void setExtension(String extension) {
		this.extension = extension;
	}
	public String getVerify() {
		return verify;
	}
	public void setVerify(String verify) {
		this.verify = verify;
	}
}
